'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _emojiCode = require('./emoji-code');

var _emojiCode2 = _interopRequireDefault(_emojiCode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function renderCode(code, children) {
  return children ? (0, _react.cloneElement)(children, { code: code }) : _react2.default.createElement(_emojiCode2.default, { code: code });
}

function EmojiItem(_ref) {
  var code = _ref.code,
      emoji = _ref.emoji,
      onPick = _ref.onPick,
      className = _ref.className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['code', 'emoji', 'onPick', 'className', 'children']);

  return _react2.default.createElement(
    'button',
    _extends({}, props, {
      type: 'button',
      'data-code': code,
      className: this.props.className,
      onClick: onPick
    }),
    emoji,
    ' ',
    this.renderCode(code, children)
  );
}

EmojiItem.propTypes = {
  code: _propTypes2.default.string.isRequired,
  emoji: _propTypes2.default.string.isRequired,
  onPick: _propTypes2.default.func.isRequired,
  className: _propTypes2.default.string,
  children: _propTypes2.default.node
};

EmojiItem.defaultProps = {
  className: 'PulseEditor-emojiItem',
  children: null
};

exports.default = EmojiItem;